/* Mlib version 3.0 by Michael McElroy
rewritten for PedroM
lord_nightrose@yahoo.com
C Source File
Originally Created 4/24/01; 9:30:30 PM
New version created 12/12/03; 10:12 PM
Mlib is a library of advanced TI-89 functions, written in C. 
Thanks to Thomas Nussbaumer and Francois Leiber for their inspiration and help,
and to Patrick Pelissier for creating the first alternative TI-89 OS! */

/* old incompatible code begins here

 #define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

// #define SAVE_SCREEN        // Save/Restore LCD Contents

 #include <tigcclib.h>         // Include All Header Files

 short _ti89;                  // Produce .89Z File

int sizeOf(SYM_ENTRY * arg);
void byte(HANDLE handle, int num);
void bytestr(HANDLE handle, int start, int num);
void setbyte(HANDLE handle, int num, int value);
void picsize(HANDLE handle);
void spriteat(unsigned short x, unsigned short y, int mode, HANDLE handle);
int ReturnBatteryState();
char * main_string = "main\0";
char * type(char *filename);
long rom(void);
unsigned short __BatteryState(unsigned short is_hw_2);
unsigned short GetBatteryState(void);

float float_x, float_y;
unsigned long len; // used by 'size' function
int ext, mode, numofarg, x, y; // used by many functions for mode settings
ESI arg; // pointer to argument list
ESI fileptr;
SYM_ENTRY *vatentry, *argument, *FPtr; // symbolic entries for finding file & folder lists
unsigned char *function, *text; // function entered, text entered as argument
SCR_RECT fullscreen = {{0,0,159,99}};
    
// Main Function

void _main(void) 
{
// setup - create all the variables we'll need

  InitArgPtr(arg); // set arg to point to the first argument
  push_END_TAG(); // begin the return list

// main function loop; loop until last argument is reached

  while(GetArgType(arg)!=END_TAG) { // loop until you reach the end of the argument list

//check to see if the current argument is a string. If not, set the function to "" (nothing)

    numofarg=RemainingArgCnt(arg); // find the number of arguments remaining
    if(GetArgType(arg) == STR_TAG) function = GetStrnArg(arg); else function = ""; // make sure the 'function' passed is a string and ONLY a string

// start checking for functions

// Major note:
// Because of the way TIGCC interprets strings, the 'strcmp' function MUST be used to compare strings.
// This function will return a 0 if the first argument is IDENTICAL to the second argument. Therefore,
// MLib will only interpret a function properly if its name is spelled correctly.


//<new for version 2.11>
		if(strcmp(function, "setbyte") == 0 && numofarg >= 3) {
      if(GetArgType(arg)!=POSINT_TAG) {x = 0; SkipArg(arg);} else x = GetIntArg(arg); // get byte number
      if(GetArgType(arg)!=POSINT_TAG) {y = 0; SkipArg(arg);} else y = GetIntArg(arg); // get byte number
      if(GetArgType(arg)!=STR_TAG) {text = ""; SkipArg(arg);} else text = GetSymstrArg(arg); // get picture file name
      FPtr = SymFindPtr(text, 1);
      if(FPtr && FPtr->name) {
        setbyte(FPtr->handle, x, y);
        printf("setbyte -> ok");
      }
		}

//</new for version 2.11>

//<new for version 2.1>
    if(strcmp(function, "execute") == 0 && numofarg >= 2) {
      if(GetArgType(arg)!=STR_TAG) {text = ""; SkipArg(arg);} else text = GetStrnArg(arg); // get picture file name
      // this is a function to show something weird I discovered. if you do a push_parse_text with EXECUTABLE code, the list
      // becomes executable! for example: push_parse_text("0x") will make it so that when you type 'ml<enter>' on the home screen,
      // the variable x is CREATED with a value of 0!!! The character '' is the PC version of the storage character ->. I've added
      // a short list of other useful characters:

      //  = conversion (|>)
      //  = var storage (->)
      //  = power of -1
      //  = derivative symbol
      //  = integrate symbol
      //  = exponential mini-'E'
      //  = ln base 'e'
      //  = imaginary 'i'
      //  = greek lower-case delta
      
      push_parse_text(text);
    }
    
    if(strcmp(function, "executeall") == 0 && numofarg >= 2) { // consider ALL the following arguments as executable, and execute them
      while(RemainingArgCnt(arg) > 0) {
        if(GetArgType(arg)!=STR_TAG) {text = ""; SkipArg(arg);} else text = GetStrnArg(arg); // get picture file name
        push_parse_text(text);
      }
    }

    if(strcmp(function, "bytes") == 0 && numofarg >= 4) { // get a byte from a file
      if(GetArgType(arg)!=POSINT_TAG) {x = 0; SkipArg(arg);} else x = GetIntArg(arg); // get byte number
      if(GetArgType(arg)!=POSINT_TAG) {y = 0; SkipArg(arg);} else y = GetIntArg(arg); // get byte number
      if(GetArgType(arg)!=STR_TAG) {text = ""; SkipArg(arg);} else text = GetSymstrArg(arg); // get picture file name
      FPtr = SymFindPtr(text, 1);
      if(FPtr && FPtr->name) {
        for(ext = x; ext < x + y; ext++) {
          byte(FPtr->handle, ext);
        }
      } else printf("bytes -> fail");
    }

    if(strcmp(function, "bytestr") == 0 && numofarg >= 4) { // get a byte from a file
      if(GetArgType(arg)!=POSINT_TAG) {x = 0; SkipArg(arg);} else x = GetIntArg(arg); // get byte number
      if(GetArgType(arg)!=POSINT_TAG) {y = 0; SkipArg(arg);} else y = GetIntArg(arg); // get byte number
      if(GetArgType(arg)!=STR_TAG) {text = ""; SkipArg(arg);} else text = GetSymstrArg(arg); // get picture file name
      FPtr = SymFindPtr(text, 1);
      if(FPtr && FPtr->name) {
        bytestr(FPtr->handle, x, y);
      } else {
        char c[y+2];
        // for(ext = 0; ext < y + 1; ext++) {
        c[0]='"';
        c[y + 1]='"';
        push_parse_text(c);
      }
    }

    if(strcmp(function, "byte") == 0 && numofarg >= 3) { // get a byte from a file
      if(GetArgType(arg)!=POSINT_TAG) {y = 0; SkipArg(arg);} else y = GetIntArg(arg); // get byte number
      if(GetArgType(arg)!=STR_TAG) {text = ""; SkipArg(arg);} else text = GetSymstrArg(arg); // get picture file name
      FPtr = SymFindPtr(text, 1);
      if(FPtr && FPtr->name) byte(FPtr->handle, y);
      else push_Float_to_nonneg_int(0);
    }

//</new for version 2.1>

//<new for version 2.04>
    if(strcmp(function, "picsize") == 0 && numofarg >= 2) { // get the size of a picture
      if(GetArgType(arg)!=STR_TAG) {text = ""; SkipArg(arg);} else text = GetSymstrArg(arg); // get picture name
      FPtr = SymFindPtr(text, 1);
      if(FPtr && FPtr->name) picsize(FPtr->handle);
    }

    if(strcmp(function, "sprite") == 0 && numofarg >= 5) { // draw a sprite
      if(GetArgType(arg)!=POSINT_TAG) {x = 0; SkipArg(arg);} else x = GetIntArg(arg); // get x position
      if(GetArgType(arg)!=POSINT_TAG) {y = 0; SkipArg(arg);} else y = GetIntArg(arg); // get y position
      if(GetArgType(arg)!=POSINT_TAG) {ext = 0; SkipArg(arg);} else ext = GetIntArg(arg); // get y position
      if(GetArgType(arg)!=STR_TAG) {text = ""; SkipArg(arg);} else text = GetSymstrArg(arg); // get picture name
      FPtr = SymFindPtr (text, 1);
      if(FPtr && FPtr->name) spriteat(x,y,ext,FPtr->handle);
    }

    if(strcmp(function, "hw2") == 0) { // get the ROM base version
       push_Float_to_nonneg_int(rom());
    }

    if(strcmp(function, "battlvl") == 0) { // get the battery level; taken from TICT Explorer code, thanks Johan Eilert and Thomas Nussbaumer
       push_Float_to_nonneg_int(ReturnBatteryState());
    }   
//</new for version 2.04>

    if(strcmp(function, "reset") == 0) OSReset(); // reset the RAM (archive is preserved)
  
    if(strcmp(function, "err") == 0 && numofarg>=2) {
      if(GetArgType(arg)!=POSINT_TAG) {mode = 0; SkipArg(arg);} else {mode = GetIntArg(arg);}
// throw a user-specified error
          ERD_dialog (mode, 0);// throw an error without aborting program execution
    }

    if(strcmp(function, "freemem") == 0) {
// return free RAM memory
      HeapCompress(); // compresses the available memory to be sure you get an accurate measurement
      push_Float_to_nonneg_int(HeapAvail());
    }

// change contrast
    if(strcmp(function, "-") == 0) OSContrastDn(); // lighter contrast

    if(strcmp(function, "+") == 0) OSContrastUp(); // darker contrast
  
// draw a string
    if(strcmp(function, "drawtxt") == 0 && numofarg >= 3) {
      if(GetArgType(arg)!=POSINT_TAG) {x = 0; SkipArg(arg);} else x = GetIntArg(arg); // get x position
      if(GetArgType(arg)!=POSINT_TAG) {y = 0; SkipArg(arg);} else y = GetIntArg(arg); // get y position
      if(GetArgType(arg)!=STR_TAG) {text = ""; SkipArg(arg);} else text = GetStrnArg(arg); // get text
      printf_xy(x,y,text,A_NORMAL); // display the text in normal mode
    }

    if(strcmp(function, "drawsl") == 0) DrawLine(0, 93, 159, 93, 1);
    
    if(strcmp(function, "font") == 0 && numofarg >= 2) {
      if(GetArgType(arg)!=POSINT_TAG) {mode = 0; SkipArg(arg);} else mode = GetIntArg(arg); // get font mode
      if(mode>=0 && mode<=2) FontSetSys(mode); // set font
    }

    if(strcmp(function, "clrscr") == 0) ClrScr(); // clear LCD

// get a key press from the user
    if(strcmp(function, "getky") == 0) push_Float_to_nonneg_int(ngetchx()); // wait for a key press and return the value
  
    if(strcmp(function, "off") == 0) off(); // turn the calculator off

    if(strcmp(function, "version") == 0) push_parse_text("\"MLib version 3.0 (PedroM edition) by Michael McElroy\""); // return version info string

    if(strcmp(function, "battery") == 0 && numofarg >= 2) {
      if(GetArgType(arg)!=POSINT_TAG) {mode = 0; SkipArg(arg);} else mode = GetIntArg(arg);
      if(mode>=0 && mode<3) ST_batt(mode); // show a battery indicator in the status bar
    }
    
    if(strcmp(function, "busy") == 0 && numofarg >= 2) {
      if(GetArgType(arg)!=POSINT_TAG) {mode = 0; SkipArg(arg);} else mode=GetIntArg(arg);
      if(mode>=0 && mode<3) ST_busy(mode); // show a busy indicator in the status bar
    }

    if(strcmp(function, "slprec") == 0 && numofarg >= 2) {
      if(GetArgType(arg)!=POSINT_TAG) {mode = 0; SkipArg(arg);} else mode = GetIntArg(arg);
      if(mode>=0 && mode<3) ST_precision(mode); // change the precision indicator in the status bar
    }

    if(strcmp(function, "slgraph") == 0 && numofarg >= 2) {
      if(GetArgType(arg) != POSINT_TAG) {mode=0; SkipArg(arg);} else mode = GetIntArg(arg);
      if(mode == 0) ST_graph(mode);
      if(mode >= 1 && mode <= 5) ST_graph(mode+1); // change the graph indicator in the status bar
    }
  
    if(strcmp(function, "slfolder") == 0 && numofarg >= 2) {
      if(GetArgType(arg) != STR_TAG) {text = "MAIN"; SkipArg(arg);} else text = GetStrnArg(arg);
      if(strlen(text) <= 8) ST_folder(text); // change the folder indicator in the status bar
    }

    if(strcmp(function, "slhelp") == 0 && numofarg >= 2) {
      if(GetArgType(arg) != STR_TAG) {text = "MAIN"; SkipArg(arg);} else text = GetStrnArg(arg);
        ST_helpMsg(text); // display a message in the status bar
    }

    if(strcmp(function, "sleep") == 0 && numofarg >= 2) {
      if(GetArgType(arg) != POSINT_TAG) {mode = 0; SkipArg(arg);} else mode = GetIntArg(arg);
      OSFreeTimer (1); // free the timer
      OSRegisterTimer (1, mode*20); // start a timer for 'mode' seconds
      while (!OSTimerExpired (1)); // idle loop until the timer reaches 0
      OSFreeTimer (1); // free the timer again
    }

// put some text in the clipboard
    if(strcmp(function, "cb") == 0 && numofarg >= 2) {
     if(GetArgType(arg) != STR_TAG) {text = ""; SkipArg(arg);} else text = GetStrnArg(arg);
     len = strlen(text);
     CB_replaceTEXT (text,len,0);
    }

// get a list of non-temporary folders
    if(strcmp(function, "folders") == 0) {
      fileptr = top_estack;
      FPtr = SymFindFirst (GetSymstrArg (fileptr), 4);
      while (FPtr) // while a folder name exists...
      {
        push_ANSI_string (FPtr->name); // add the folder name to the returned list
        FPtr = SymFindNext (); // find the next folder name
      }
    }

// get a list of files in a folder
    if(strcmp(function, "files") == 0 && numofarg >= 2) {
      if(GetArgType(arg) != STR_TAG) {FPtr = SymFindFirst ("main", 1); SkipArg(arg);} else FPtr = SymFindFirst (GetSymstrArg (arg), 1);
      // get a symbolic (variable name) argument from the top of the estack
      // (basically the first byte in the file allocation table), then search
      // for the first occurance of that name
      
      while (FPtr) { // while a file name still exists...
        push_ANSI_string (FPtr->name); // add the file name to the returned list
        FPtr = SymFindNext (); // find the next file name
      }
    }
    
// Note about 'folders' and 'files':
// The 'SymFindNext' function acts in conjunction with the 'SymFindFirst' function. Whatever
// type of file/folder is passed to 'SymFindFirst' is the type of file/folder that will be
// searched for with 'SymFindNext'.

// find a file's size
    if(strcmp(function, "size") == 0 && numofarg >= 2) {
      if(GetArgType(arg) != STR_TAG) {argument = (SYM_ENTRY *)main_string; SkipArg(arg);} else text = GetSymstrArg (arg);
      push_Float_to_nonneg_int(sizeOf((SYM_ENTRY *)text));
    }    
  }
  
  push_reversed_tail(top_estack); // <--- reverses the list - thanks to Thomas Nussbaumer for his help here!
  push_LIST_TAG (); // finally, push a byte which tells the calculator that the variable to return is a list
}

//===========================================================================
// evaluates battery state (if argument is 0 it assumes HW1 else HW2)        
//                                                                           
// returns:                                                                  
//                                                                           
// 7 - full        battery state                                             
// 6 - ok          battery state                                             
// 5 - medium      battery state                                             
// 4 - low         battery state (battery symbol appears)                    
// 3 - very low    battery state (battery symbol darkened)                   
// 2 - starving    battery state (battery symbol darkened)                   
// 1 - almost dead battery state (battery symbol darkened)                   
// 0 - dead        battery state (calc resetted)                             
//                                                                           
// NOTE: The BATT symbol will be turned on by the AMS                        
//===========================================================================

unsigned short __BatteryState(unsigned short is_hw_2);
asm("__BatteryState:\n"\
"         movem.l  %d2/%a0,-(%sp)\n"\
"         clr.w    %d0\n"\
"         tst.w    12(%sp)\n"\ // jump for HW1
"         beq     __h1_1\n"\
"         movea.l #0x70001D,%a0\n"\ // set a0 to battery checker on register
"         move.b  (%a0),%d2\n"\
"         ori.b   #9,%d2\n"\
"         move.b  %d2,(%a0)\n"\
"__h1_1:  movea.l #0x600018,%a0\n"\  // set a0 to trigger level set register
"__next:  move.w  %d0,(%a0)\n"\ // set new trigger level
"         moveq   #0x6E,%d2\n"\ // loop for a while testing it
"__test:  btst.l  #2,(0x600000)\n"\ // check if voltage is above trigger level
"         dbra    %d2,__test\n"\ // not only once, but loop for a while ...
"         bne     __fine\n"\
"         add.w   #0x80,%d0\n"\// set another trigger level
"         cmp.w   #0x380,%d0\n"\
"         bne     __next\n"\
"__fine:  move.w  #0x380,(%a0)\n"\
"         lsr.w   #7,%d0\n"\
"         tst.w   12(%sp)\n"\
"         beq     __h1_2\n"\ // jump for HW1
"         movea.l #0x70001D,%a0\n"\ // set a0 to battery checker on register
"         move.b  (%a0),%d2\n"\
"         andi.b  #0xF7,%d2\n"\
"         move.b  %d2,(%a0)\n"\
"         moveq   #0x52,%d2\n"\ // how long should I loop for testing?
"__fin2:  btst.l  #2,(0x600000)\n"\ // check if voltage is above trigger level
"         dbne    %d2,__fin2\n"\ // not only once, but loop for a while ...
"         move.b  (%a0),%d2\n"\
"         andi.b  #0xF6,%d2\n"\
"         move.b  %d2,(%a0)\n"\
"__h1_2:  movem.l (%sp)+,%d2/%a0\n"\
"         rts");


//===========================================================================
// battery state fetching routine                                            
//===========================================================================
unsigned short GetBatteryState() {
    unsigned long hwpb, *rombase;
    unsigned short level;
    rombase = (unsigned long *)((*(unsigned long *)0xC8) & 0x600000);
    hwpb = rombase[65];
    OSSetSR(0x700);
    level = __BatteryState(((unsigned short)(hwpb - (unsigned long)rombase  < 0x10000 &&
       *(unsigned short *)hwpb > 22 ? *(unsigned long *)(hwpb + 22) : 1) - 1L));
    OSSetSR(0x0);
    return level;
}

long rom(void) {
    unsigned long hwpb, *rombase;
    rombase = (unsigned long *)((*(unsigned long *)0xC8) & 0x600000);
    hwpb = rombase[65];
    OSSetSR(0x700);
    hwpb = ((unsigned short)(hwpb - (unsigned long)rombase  < 0x10000 &&
       *(unsigned short *)hwpb > 22 ? *(unsigned long *)(hwpb + 22) : 1) - 1L);
    OSSetSR(0x0);
    return hwpb;
}


// file type retrieval routine
char * type(char *filename) {
    SYM_ENTRY *file;
    file = SymFindFirst(filename,1);
    if(file && file->name) {
        ext = *(unsigned char*)HToESI(file->handle);
        text = HeapDeref(file->handle); // here, text is really the file's name; finds the file's starting byte in the variable allocation table
        //                len = *(unsigned short*)(text)+2; // quick and easy way to calculate the size once you know where the handle is
        //                push_Float_to_nonneg_int(len);
        return text;
    } else {
        return "nonexistent";
    }
}

int ReturnBatteryState() {
    unsigned short bs = GetBatteryState();

    if (bs>5) bs = 0;
    else      bs = 6 - bs;

    return bs;
}

void byte(HANDLE handle, int num) {
    unsigned char* src;
    
    src = HeapDeref(handle);
    push_Float_to_nonneg_int((int)(src[num-1]));
}

void setbyte(HANDLE handle, int num, int value) {
    unsigned char* src;
    
    src = HeapDeref(handle);
    src[num-1] = value;
}

void bytestr(HANDLE handle, int start, int num) {
    unsigned char * src;
    unsigned char chrs[num + 1];
    int i;
    
    src = HeapDeref(handle);
    //chrs[0]='"';
    //chrs[num + 1]='"';
    chrs[num]='\0';
    for (i = 0; i < num; i++) {
      chrs[i] = src[i + start - 1];
      if(src[i + start - 1] == '\0') chrs[i] = ''; // this isn't actually a space; it's ASCII character #160, which equates to '...' on a TI-89
      if(src[i + start - 1] == '"') chrs[i] = '\'';
      if(src[i + start - 1] == ' ') chrs[i] = '';
    }
    printf(chrs);
    //push_parse_text(chrs);
}

void picsize(HANDLE handle) {
    unsigned char* src;
    int height, width;

    src = HeapDeref(handle);
    
    height = ((BITMAP*)(src+2))->NumRows;
    width = ((BITMAP*)(src+2))->NumCols;
    push_Float_to_nonneg_int(height);
    push_Float_to_nonneg_int(width);
}

void spriteat(unsigned short x, unsigned short y, int mode, HANDLE handle) {
    unsigned char* src;
    int height, width;

    src = HeapDeref(handle);
    height = ((BITMAP*)(src+2))->NumRows + 2;
    width = ((BITMAP*)(src+2))->NumCols + 2;

    BitmapPut(x,y,src+2,&fullscreen,mode);
}      

int sizeOf(SYM_ENTRY * arg) {
  vatentry = DerefSym(SymFind((char *)arg)); // dereference ('make into Plain English', basically) a symbol
  if(vatentry && vatentry->name) { // make sure the file exists and its name exists
    text = HeapDeref(vatentry->handle); // here, text is really the file's name; finds the file's starting point in the variable allocation table
    len = *(unsigned short*)(text)+2; // quick and easy way to calculate the size once you know where the handle is
    return len;
  } else return 0;
}

//That's all, folks!
old incompatible code ends here */

// includes
#include "stdio.h"            // standard PedroM include
#include <tigcclib.h>         // Include All TIGCC Header Files

// subroutines
void byte(HANDLE handle, int num);
void setbyte(HANDLE handle, int num, int value);
char *IntToStr (int an_integer);
void picsize(HANDLE handle);
int ReturnBatteryState();
long rom(void);
unsigned short __BatteryState(unsigned short is_hw_2);
unsigned short GetBatteryState(void);
int GetIntArgFromStrnArg(ESI arg);
int sizeOf(SYM_ENTRY * arg);
void spriteat(unsigned short x, unsigned short y, int mode, HANDLE handle);
void printl(char * x);

// variables
int fail;
float float_x, float_y;
unsigned long len; // used by 'size' function
int ext, mode, x, y; // used by many functions for mode settings
ESI arg; // pointer to argument list
ESI fileptr;
SYM_ENTRY *vatentry, *argument, *FPtr; // symbolic entries for finding file & folder lists
unsigned char *function, *text; // function entered, text entered as argument
SCR_RECT fullscreen = {{0,0,159,99}};

// main function
int main() {
  InitArgPtr(arg); // set arg to point to the first argument
  if(GetArgType(arg) == STR_TAG) function = GetStrnArg(arg); else function = ""; // make sure the 'function' passed is a string and ONLY a string

  // select the function to execute

  // Major note:
  // Because of the way TIGCC interprets strings, the 'strcmp' function MUST be used to compare strings.
  // This function will return a 0 if the first argument is IDENTICAL to the second argument. Therefore,
  // MLib will only interpret a function properly if its name is spelled correctly.

  fail = 1;
  
  // get a list of non-temporary folders
  if(strcmp(function, "folders") == 0) {
    fileptr = top_estack;
    FPtr = SymFindFirst (GetSymstrArg (fileptr), 4);
    x = 0;
    while (FPtr) // while a folder name exists...
    {
      printf("   \\");
      printl(FPtr->name); // add the folder name to the returned list
      FPtr = SymFindNext (); // find the next folder name
      x++;
    }
    fail = 0;
    printf(" ");
    printf(IntToStr(x));
    printf(" folder(s)\n");
  }
  
  if(strcmp(function, "picsize") == 0) { // get the size of a picture
    if(GetArgType(arg)!=STR_TAG) {
    	printf("usage: mlib picsize <picname>\n");
    }
    else {    	
      text = GetSymstrArg(arg); // get picture name
      FPtr = SymFindPtr(text, 1);
      fail = 0;
      if(FPtr && FPtr->name) picsize(FPtr->handle);
      else { printf("file not found. usage: mlib picsize <picname>\n"); }
    }
  }

  if(strcmp(function, "reset") == 0) {
    printf("press ON to confirm, anything else to cancel.\n");
    fail = 0;
    if(ngetchx()==267) OSReset();
    printf("Reset cancelled.\n");
    // reset the RAM (archive is preserved)	
  }

// get a list of files in a folder
  if(strcmp(function, "files") == 0) {
    if(GetArgType(arg) != STR_TAG) {
    	printf("usage: mlib files <folder>\n");
    } else {
      FPtr = SymFindFirst (GetSymstrArg (arg), 1);
      // get a symbolic (variable name) argument from the top of the estack
      // (basically the first byte in the file allocation table), then search
      // for the first occurance of that name
		  InitArgPtr(arg);
		  SkipArg(arg);
      printf("Directory of '");
      printf(GetStrnArg(arg));
      printf("'\n");
      x = 0;
      while (FPtr) { // while a file name still exists...
        printf("   ");
        printl(FPtr->name); // add the folder name to the returned list
        FPtr = SymFindNext (); // find the next folder name
        x++;
        fail = (x == 0);
      }
      printf(" ");
      printf(IntToStr(x));
      printf(" file(s)\n");
    }
  }

  if(strcmp(function, "-") == 0) { OSContrastDn(); fail = 0; } // lighter contrast

  if(strcmp(function, "+") == 0) { OSContrastUp(); fail = 0; } // darker contrast

  if(strcmp(function, "hw2") == 0) { // get the ROM base version
    fail = 0;
    printl(IntToStr(rom()));
  }

  if(strcmp(function, "battlvl") == 0) { // get the battery level; taken from TICT Explorer code, thanks Johan Eilert and Thomas Nussbaumer
    fail = 0;
    printl(IntToStr(ReturnBatteryState()));
  }

  if(strcmp(function, "getky") == 0) { fail = ngetchx(); printl(IntToStr(fail));} // wait for a key press and return the value
  
  if(strcmp(function, "off") == 0) {fail = 0; off(); } // turn the calculator off

  if(strcmp(function, "clrscr") == 0) { fail = 0; ClrScr(); } // clear LCD

  if(strcmp(function, "version") == 0) { fail = 0; printf("MLib version 3.0 (PedroM edition)\nby Michael McElroy\n"); } // return version info string

  if(strcmp(function, "battery") == 0) {
  	if(GetArgType(arg)!=POSINT_TAG && GetArgType(arg)!=STR_TAG) {
  		printf("usage: mlib battery <mode>\n");
  	} else {
      mode = GetIntArgFromStrnArg(arg);
      SkipArg(arg);
      if(mode>=0 && mode<3) {
      	fail = 0;
      	printl(IntToStr(mode));
      	ST_batt(mode); // show a battery indicator in the status bar
      } else {
      	printf("mode must be between 0 and 2\n");
      }
    }
  }
    
  if(strcmp(function, "busy") == 0) {
  	if(GetArgType(arg)!=POSINT_TAG && GetArgType(arg)!=STR_TAG) {
  		printf("usage: mlib busy <mode>\n");
  	} else {
      mode = GetIntArgFromStrnArg(arg);
      SkipArg(arg);
      if(mode>=0 && mode<3) {
      	fail = 0;
      	printl(IntToStr(mode));
      	ST_busy(mode); // show a busy indicator in the status bar
      } else {
      	printf("mode must be between 0 and 2\n");
      }
    }
  }

  if(strcmp(function, "slprec") == 0) {
  	if(GetArgType(arg)!=POSINT_TAG && GetArgType(arg)!=STR_TAG) {
  		printf("usage: mlib slprec <mode>\n");
  	} else {
      mode = GetIntArgFromStrnArg(arg);
      SkipArg(arg);
      if(mode>=0 && mode<3) {
      	fail = 0;
      	printl(IntToStr(mode));
      	ST_precision(mode); // change the precision indicator in the status bar
      } else {
      	printf("mode must be between 0 and 2\n");
      }
    }
  }

  if(strcmp(function, "slgraph") == 0) {
  	if(GetArgType(arg)!=POSINT_TAG && GetArgType(arg)!=STR_TAG) {
  		printf("usage: mlib slgraph <mode>\n");
  	} else {
      mode = GetIntArgFromStrnArg(arg);
      SkipArg(arg);
      if(mode>=0 && mode<3) {
      	fail = 0;
      	printl(IntToStr(mode));
      	ST_graph(mode); // change the graph indicator in the status bar
      } else {
      	printf("mode must be between 0 and 2\n");
      }
    }
  }
  
  if(strcmp(function, "slfolder") == 0) {
  	if(GetArgType(arg)!=STR_TAG) {
  		printf("usage: mlib slfolder <text>\n");
  	} else {
      text = GetStrnArg(arg);
      fail = 0;
      printl(text);
      ST_folder(text); // change the folder indicator in the status bar
    }
  }

  if(strcmp(function, "slhelp") == 0) {
  	if(GetArgType(arg)!=STR_TAG) {
  		printf("usage: mlib slhelp <text>\n");
  	} else {
      text = GetStrnArg(arg);
      fail = 0;
      printl(text);
      ST_helpMsg(text); // display a message in the status bar
    }
  }

  if(strcmp(function, "sleep") == 0) {
  	if(GetArgType(arg)!=POSINT_TAG && GetArgType(arg)!=STR_TAG) {
  		printf("usage: mlib sleep <time>\n");
  	} else {
      fail = 0;
      mode = GetIntArgFromStrnArg(arg);
      SkipArg(arg);
      OSFreeTimer (1); // free the timer
      OSRegisterTimer (1, mode*20); // start a timer for 'mode' seconds
      while (!OSTimerExpired (1)); // idle loop until the timer reaches 0
      OSFreeTimer (1); // free the timer again
      printl(IntToStr(mode));
    }
  }

// find a file's size
  if(strcmp(function, "size") == 0) {
    if(GetArgType(arg) != STR_TAG) {
      printf("usage: mlib size <file>\n");
    }
    else {
      fail = 0;	
      text = GetSymstrArg (arg);
      printl(IntToStr(sizeOf((SYM_ENTRY *)text)));
    }
  }    
  
  if(strcmp(function, "err") == 0) {
    if(GetArgType(arg)!=POSINT_TAG && GetArgType(arg)!=STR_TAG) {
    	printf("usage: mlib err <error_number>\n");
    } else {
    	fail = 0;
    	mode = GetIntArg(arg); // throw a user-specified error
      ERD_dialog (mode, 0);// throw an error without aborting program execution
      printl(IntToStr(mode));
    }
  }

  //draw a sprite. modes: inverted, or, xor, blank, normal, or, and
  if(strcmp(function, "sprite") == 0) { // draw a sprite
    if(GetArgType(arg)!=POSINT_TAG && GetArgType(arg)!=STR_TAG) {
    	printf("usage: mlib sprite <X> <y>\n<mode> <image_file>\n");
    } else {
    	x = GetIntArgFromStrnArg(arg);
    	SkipArg(arg);
      if(GetArgType(arg)!=POSINT_TAG && GetArgType(arg)!=STR_TAG) {
      	printf("usage: mlib sprite <x> <Y>\n<mode> <image_file>\n");
      } else {
      	y = GetIntArgFromStrnArg(arg);
      	SkipArg(arg);
        if(GetArgType(arg)!=POSINT_TAG && GetArgType(arg)!=STR_TAG) {
        	printf("usage: mlib sprite <x> <y>\n<MODE> <image_file>\nmodes: 0=inverted, 1=or, 2=xor, 3=blank, 4=normal, 5=and\n");
        } else {
        	mode = GetIntArgFromStrnArg(arg);        	
        	SkipArg(arg);
        	if(mode == 6) mode = 5;
          if(GetArgType(arg)!=STR_TAG) {
           	printf("usage: mlib sprite <x> <y>\n<mode> <IMAGE_FILE>\n");
          } else { 
            text = GetSymstrArg(arg); // get picture name
            
            FPtr = SymFindPtr (text, 1);
            if(FPtr && FPtr->name) {
            	fail = 0;
            	spriteat(x,y,mode,FPtr->handle);
            	printf("Done\n");
            } else {
            	printf(IntToStr(sizeOf((SYM_ENTRY *)text)));
            	InitArgPtr(arg);
            	SkipArg(arg);
            	SkipArg(arg);
            	SkipArg(arg);
            	printf("file ");
            	printf(GetStrnArg(arg));
            	printf(" not found. usage: mlib sprite\n<x> <y> <mode> <IMAGE_FILE>\n");
            }
          }
        }
      }
    }
  }

  if(strcmp(function, "drawtxt") == 0) { // draw text
    if(GetArgType(arg)!=POSINT_TAG && GetArgType(arg)!=STR_TAG) {
    	printf("usage: mlib drawtxt <X> <y>\n<mode> <text>\n");
    } else {
    	x = GetIntArgFromStrnArg(arg);
    	SkipArg(arg);
      if(GetArgType(arg)!=POSINT_TAG && GetArgType(arg)!=STR_TAG) {
      	printf("usage: mlib drawtxt <x> <Y>\n<mode> <text>\n");
      } else {
      	y = GetIntArgFromStrnArg(arg);
      	SkipArg(arg);
        if(GetArgType(arg)!=POSINT_TAG && GetArgType(arg)!=STR_TAG) {
        	printf("usage: mlib drawtxt <x> <y>\n<MODE> <text>\n");
        } else {
        	mode = GetIntArgFromStrnArg(arg);
        	SkipArg(arg);
          if(GetArgType(arg)!=STR_TAG) {
           	printf("usage: mlib drawtxt <x> <y>\n<mode> <TEXT>\n");
          } else { 
            text = GetStrnArg(arg);
            fail = 0;
            printf_xy(x,y,text,mode);
            printf("Done\n");
          }
        }
      }
    }
  }

  if(strcmp(function, "drawsl") == 0) { fail = 0; DrawLine(0, 93, 159, 93, 1); }

  if(strcmp(function, "font") == 0) {
    if(GetArgType(arg)!=POSINT_TAG && GetArgType(arg)!=STR_TAG) {
    	printf("usage: font <mode>\n");
    } else{
    	mode = GetIntArgFromStrnArg(arg); // get font mode
    	SkipArg(arg);
      if(mode>=0 && mode<=2) {
      	fail = 0;
      	FontSetSys(mode); // set font
      } else {
      	printf("mode must be between 0 and 2\n");
      }
    }
  }

  if(strcmp(function, "setbyte") == 0) {
    if(GetArgType(arg)!=POSINT_TAG && GetArgType(arg)!=STR_TAG) {
    	printf("usage: mlib setbyte <BYTE> <value> <file>\n");
    } else {
    	x = GetIntArgFromStrnArg(arg); // get byte number
    	SkipArg(arg);
      if(GetArgType(arg)!=POSINT_TAG && GetArgType(arg)!=STR_TAG) {
      	printf("usage: mlib setbyte <byte> <VALUE> <file>\n");
      } else {
        y = GetIntArgFromStrnArg(arg); // new byte value
        SkipArg(arg);
        if(GetArgType(arg)!=STR_TAG) {
        	printf("usage: mlib setbyte <byte> <value> <FILE>\n");
        } else {
        	text = GetSymstrArg(arg); // get file name
          FPtr = SymFindPtr(text, 1);
          if(FPtr && FPtr->name) {
            fail = 0;
            setbyte(FPtr->handle, x, y);
            printf("setbyte -> ok");
          } else {
          	printf("file not found. usage: mlib setbyte <byte> <value> <file>\n");
          }
        }
      }
    }
  }

  if(strcmp(function, "execute") == 0) {
    if(GetArgType(arg)!=STR_TAG) {
      printf("usage: mlib execute <command>\n");
    } else {
      fail = 0;
    	text = GetStrnArg(arg); // get picture file name
      push_parse_text(text);
    }
  }

  if(strcmp(function, "executeall") == 0) { // consider ALL the following arguments as executable, and execute them
    while(RemainingArgCnt(arg) > 0) {
      if(GetArgType(arg)!=STR_TAG) {
      	SkipArg(arg);
      } else {
      	fail = 0;
      	text = GetStrnArg(arg); // get picture file name
        push_parse_text(text);
      }
    }
  }

  if(strcmp(function, "bytes") == 0) { // get a string of bytes from a file
    if(GetArgType(arg)!=POSINT_TAG && GetArgType(arg)!=STR_TAG) {
      printf("usage: mlib bytes <BEGIN> <end> <file>\n");
    } else {
    	x = GetIntArgFromStrnArg(arg); // get first byte number
    	SkipArg(arg);
      if(GetArgType(arg)!=POSINT_TAG && GetArgType(arg)!=STR_TAG) {
        printf("usage: mlib bytes <begin> <END> <file>\n");
      } else {
      	y = GetIntArgFromStrnArg(arg); // get last byte number
      	SkipArg(arg);
        if(GetArgType(arg)!=STR_TAG) {
          printf("usage: mlib bytes <begin> <end> <FILE>\n");
        } else {
        	text = GetSymstrArg(arg); // get  file name
          FPtr = SymFindPtr(text, 1);
          if(FPtr && FPtr->name) {
            fail = 0;
            printf("{");
            for(mode = x; mode < y; mode++) {
            	printf(bytei(FPtr->handle, mode));
            	printf(",");
            }
            printf("}\n");
          } else {
          	printf("file not found. usage: mlib bytes <begin> <end> <file>\n");
          }
        }
      }
    }
  }

  if(strcmp(function, "bytestr") == 0) { // get a string of bytes from a file
    if(GetArgType(arg)!=POSINT_TAG && GetArgType(arg)!=STR_TAG) {
      printf("usage: mlib bytestr <BEGIN> <end> <file>\n");
    } else {
    	x = GetIntArgFromStrnArg(arg); // get first byte number
    	SkipArg(arg);
      if(GetArgType(arg)!=POSINT_TAG && GetArgType(arg)!=STR_TAG) {
        printf("usage: mlib bytestr <begin> <END> <file>\n");
      } else {
      	y = GetIntArgFromStrnArg(arg); // get last byte number
      	SkipArg(arg);
        if(GetArgType(arg)!=STR_TAG) {
          printf("usage: mlib bytestr <begin> <end> <FILE>\n");
        } else {
        	text = GetSymstrArg(arg); // get  file name
          FPtr = SymFindPtr(text, 1);
          if(FPtr && FPtr->name) {
            fail = 0;
            printf("\"");
            for(mode = x; mode < y; mode++) {
            	printf(bytei(FPtr->handle, mode));
            }
            printf("\"\n");
          } else {
          	printf("file not found. usage: mlib bytestr <begin> <end> <file>\n");
          }
        }
      }
    }
  }

  if(strcmp(function, "byte") == 0) { // get a byte from a file
    if(GetArgType(arg)!=POSINT_TAG && GetArgType(arg)!=STR_TAG) {
    	printf("usage: mlib byte <NUMBER> <file>\n");
    } else {
    	y = GetIntArgFromStrnArg(arg); // get byte number
    	SkipArg(arg);
      if(GetArgType(arg)!=STR_TAG) {
      	printf("usage: mlib byte <number> <FILE>\n");
      } else {
        text = GetSymstrArg(arg); // get picture file name
        FPtr = SymFindPtr(text, 1);
        if(FPtr && FPtr->name) {
        	fail = 0;
        	byte(FPtr->handle, y);
        } else {
        	printf("file not found. usage: mlib byte <number> <file>\n");
        }
      }
    }
  }

  // put some text in the clipboard
  if(strcmp(function, "cb") == 0) {
  	if(GetArgType(arg) != STR_TAG) {
  		printf("usage: mlib cb <text>\n");
  	} else {
  		fail = 0;
  		text = GetStrnArg(arg);
      len = strlen(text);
      CB_replaceTEXT (text,len,0);
      printl(text);
    }
  }

  if(fail==1) printf("Error\n");
  return fail;
}

char *IntToStr (int an_integer) // thanks, Samuel Stearley
{
  static char result [] = "          \0";    // 10 spaces and \0
  char *ptr = result + 10;
  do{
      *ptr-- = an_integer % 10 + '0';
      an_integer/=10;
    } while( (an_integer) );
  return ptr+1;
}

void picsize(HANDLE handle) {
    unsigned char* src;
    int height, width;

    src = HeapDeref(handle);
    
    height = ((BITMAP*)(src+2))->NumRows;
    width = ((BITMAP*)(src+2))->NumCols;
    printf(IntToStr(width));
    printf("x");
    printl(IntToStr(height));
}

//===========================================================================
// evaluates battery state (if argument is 0 it assumes HW1 else HW2)        
//                                                                           
// returns:                                                                  
//                                                                           
// 7 - full        battery state                                             
// 6 - ok          battery state                                             
// 5 - medium      battery state                                             
// 4 - low         battery state (battery symbol appears)                    
// 3 - very low    battery state (battery symbol darkened)                   
// 2 - starving    battery state (battery symbol darkened)                   
// 1 - almost dead battery state (battery symbol darkened)                   
// 0 - dead        battery state (calc resetted)                             
//                                                                           
// NOTE: The BATT symbol will be turned on by the AMS                        
//===========================================================================

unsigned short __BatteryState(unsigned short is_hw_2);
asm("__BatteryState:\n"\
"         movem.l  %d2/%a0,-(%sp)\n"\
"         clr.w    %d0\n"\
"         tst.w    12(%sp)\n"\ // jump for HW1
"         beq     __h1_1\n"\
"         movea.l #0x70001D,%a0\n"\ // set a0 to battery checker on register
"         move.b  (%a0),%d2\n"\
"         ori.b   #9,%d2\n"\
"         move.b  %d2,(%a0)\n"\
"__h1_1:  movea.l #0x600018,%a0\n"\  // set a0 to trigger level set register
"__next:  move.w  %d0,(%a0)\n"\ // set new trigger level
"         moveq   #0x6E,%d2\n"\ // loop for a while testing it
"__test:  btst.l  #2,(0x600000)\n"\ // check if voltage is above trigger level
"         dbra    %d2,__test\n"\ // not only once, but loop for a while ...
"         bne     __fine\n"\
"         add.w   #0x80,%d0\n"\// set another trigger level
"         cmp.w   #0x380,%d0\n"\
"         bne     __next\n"\
"__fine:  move.w  #0x380,(%a0)\n"\
"         lsr.w   #7,%d0\n"\
"         tst.w   12(%sp)\n"\
"         beq     __h1_2\n"\ // jump for HW1
"         movea.l #0x70001D,%a0\n"\ // set a0 to battery checker on register
"         move.b  (%a0),%d2\n"\
"         andi.b  #0xF7,%d2\n"\
"         move.b  %d2,(%a0)\n"\
"         moveq   #0x52,%d2\n"\ // how long should I loop for testing?
"__fin2:  btst.l  #2,(0x600000)\n"\ // check if voltage is above trigger level
"         dbne    %d2,__fin2\n"\ // not only once, but loop for a while ...
"         move.b  (%a0),%d2\n"\
"         andi.b  #0xF6,%d2\n"\
"         move.b  %d2,(%a0)\n"\
"__h1_2:  movem.l (%sp)+,%d2/%a0\n"\
"         rts");


//===========================================================================
// battery state fetching routine                                            
//===========================================================================
unsigned short GetBatteryState() {
    unsigned long hwpb, *rombase;
    unsigned short level;
    rombase = (unsigned long *)((*(unsigned long *)0xC8) & 0x600000);
    hwpb = rombase[65];
    OSSetSR(0x700);
    level = __BatteryState(((unsigned short)(hwpb - (unsigned long)rombase  < 0x10000 &&
       *(unsigned short *)hwpb > 22 ? *(unsigned long *)(hwpb + 22) : 1) - 1L));
    OSSetSR(0x0);
    return level;
}

long rom(void) {
    unsigned long hwpb, *rombase;
    rombase = (unsigned long *)((*(unsigned long *)0xC8) & 0x600000);
    hwpb = rombase[65];
    OSSetSR(0x700);
    hwpb = ((unsigned short)(hwpb - (unsigned long)rombase  < 0x10000 &&
       *(unsigned short *)hwpb > 22 ? *(unsigned long *)(hwpb + 22) : 1) - 1L);
    OSSetSR(0x0);
    return hwpb;
}

int GetIntArgFromStrnArg(ESI arg) {
  return atoi(GetStrnArg(arg));
}

int ReturnBatteryState() {
    unsigned short bs = GetBatteryState();

    if (bs>5) bs = 0;
    else      bs = 6 - bs;

    return bs;
}

int sizeOf(SYM_ENTRY * arg) {
  vatentry = DerefSym(SymFind((char *)arg)); // dereference ('make into Plain English', basically) a symbol
  if(vatentry && vatentry->name) { // make sure the file exists and its name exists
    text = HeapDeref(vatentry->handle); // here, text is really the file's name; finds the file's starting point in the variable allocation table
    len = *(unsigned short*)(text)+2; // quick and easy way to calculate the size once you know where the handle is
    return len;
  } else return 0;
}

void spriteat(unsigned short x, unsigned short y, int mode, HANDLE handle) {
    unsigned char* src;
    int height, width;

    src = HeapDeref(handle);
    height = ((BITMAP*)(src+2))->NumRows + 2;
    width = ((BITMAP*)(src+2))->NumCols + 2;

    BitmapPut(x,y,src+2,&fullscreen,mode);
}      

void printl(char * x) {
	printf(x);
	printf("\n");
}

int bytei(HANDLE handle, int num) {
    unsigned char* src;
    
    src = HeapDeref(handle);
    return (int)(src[num-1]);
}

void byte(HANDLE handle, int num) {
    printl(bytei(handle, num));
}

void setbyte(HANDLE handle, int num, int value) {
    unsigned char* src;
    
    src = HeapDeref(handle);
    src[num-1] = value;
}
